<?php
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/payment.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/base.php');
require_once (JPATH_SITE.'/components/com_j2store/helpers/utilities.php');

class plgJ2StorePayment_cashbill extends J2StorePaymentPlugin {
    
var $_element    = 'payment_cashbill';
var $_j2version = null;
var $_isLog      = false;
var $userid = '';
var $userkey = '';

function plgJ2StorePayment_cashbill(& $subject, $config)
{
    parent::__construct($subject, $config);
        $this->userid = $this->_getParam( 'user_id' );
        $this->userkey = $this->_getParam( 'user_key' );

        $this->_j2version = $this->getVersion();
        
        if($this->params->get('debug', 0)) {
            $this->_isLog = true;
        }
        
}


	function _prePayment( $data )
	{
	    $vars = new JObject();
	    $vars->url = JRoute::_( "index.php?option=com_j2store&view=checkout" );
	    $vars->order_id = $data['order_id'];
	    $vars->orderpayment_id = $data['orderpayment_id'];
	    $vars->orderpayment_type = $this->_element;
	    $vars->message = "Po kliknięciu zostaniesz przeniesiony na stronę płatności";
	
	    $html = $this->_getLayout('prepayment', $vars);
	    return $html;
	}


	function _postPayment( $data )
	{
	    $vars = new JObject();
	    
	    $app =JFactory::getApplication();
	    $paction = $app->input->getString('paction' );
	
	    switch ($paction) {
	       case 'status':
	          echo $this->_cashBillCallback();
	          $app->close();     
	       break;
	       case 'process':
	           echo $this->_formCreator();
	           $app->close();
	       break;
	       default:
	           $html = $this->_getLayout('message', $vars);
	       break;
	    }
	    return $html;
	}
	
	function _cashBillCallback()
	{
	    
	    if(md5($_POST['service'].$_POST['orderid'].$_POST['amount'].$_POST['userdata'].$_POST['status'].$this->userkey) == $_POST['sign'])
	    {
	    $order_id = $_POST['userdata'];
	    
	    $orderinfo = $this->_getOrderInfo($order_id);
	    $orderpayment = JTable::getInstance('Orders', 'Table');
	    $orderpayment->load($this->_getOrderPaymentId($order_id));
	    
	    if(strtoupper($_POST['status']) == 'OK')
	    {
        $orderpayment->transaction_details  = 'Płatność w kwocie '.$_POST['amount'].' została przyjęta przez CashBill.pl';
        $orderpayment->transaction_id       = $_POST['orderid'];
        $orderpayment->transaction_status = 'Płatność przyjęta';
	    $orderpayment->order_state = 'Zapłacono';
	    $orderpayment->order_state_id = $this->_getParam( 'payment_status_success' );
	    $orderpayment->save();
	    J2StoreOrdersHelper::sendUserEmail($orderpayment->user_id, $orderpayment->order_id, $orderpayment->order_state, $orderpayment->order_state, $orderpayment->order_state_id);
	    }
	    
	    if(strtoupper($_POST['status']) == 'ERR')
	    {
	    $orderpayment->transaction_details  = 'Płatność nie została zaksięgowana przez CashBill.pl';
	    $orderpayment->transaction_id       = $_POST['orderid'];
	    $orderpayment->transaction_status = 'Płatność nie przyjęta';
	    $orderpayment->order_state = 'Nie Zapłacona';
	    $orderpayment->order_state_id = $this->_getParam( 'payment_status_failed' );
	    $orderpayment->save();
	    J2StoreOrdersHelper::sendUserEmail($orderpayment->user_id, $orderpayment->order_id, $orderpayment->order_state, $orderpayment->order_state, $orderpayment->order_state_id);
	    }
	    
	    echo 'OK';
	    exit();
	    }
	    
	    echo 'BLAD SYGNATURY';

	}
	
	function _formCreator()
	{
	    if ( ! JRequest::checkToken() ) {
	        return '';
	    } 
	$app = JFactory::getApplication();
	$data = $app->input->getArray($_POST);
	JTable::addIncludePath( JPATH_ADMINISTRATOR.'/components/com_j2store/tables' );
	$order = JTable::getInstance('Orders', 'Table');
	$order->load( $data['orderpayment_id'] );
	
	$orderinfo = $this->_getOrderInfo($order->id);
	$amount = $this->getAmount($order->orderpayment_amount, $currency_values['currency_code'], $currency_values['currency_value'], $currency_values['convert']);
	$hidden = array(
	    'service'=>$this->userid,
	    'amount'=>$amount,
	    'desc'=>'Zamówienie nr : '.$order->order_id,
	    'userdata'=>$order->order_id,
	    'ref'=>'J2Store',
	    'forname'=> $orderinfo->billing_first_name,
	    'surname'=> $orderinfo->billing_last_name,
	    'email'=>$orderinfo->user_email,
	    'street'=>$orderinfo->billing_address_1,
	    'city'=>$orderinfo->billing_city,
	    'postcode'=>$orderinfo->billing_zip,
	    'country'=>$this->_getCountryCode($orderinfo->billing_country_id)->country_isocode_2,
	);
	
	$sign = md5(implode("",$hidden).$this->userkey);
	$hidden['sign'] = $sign;
	
	
	$vars = new JObject();
	$vars->url = 'https://pay.cashbill.pl/form/pay.php';
	$vars->data = $hidden;
	$vars->orderpayment_type = $this->_element;
	
	
	$orderinfo = $this->_getOrderInfo($order->order_id);
	$orderpayment = JTable::getInstance('Orders', 'Table');
	$orderpayment->load($this->_getOrderPaymentId($order->order_id));
	
	$orderpayment->order_state = 'Rozpoczęta';
	$orderpayment->order_state_id = $this->_getParam( 'payment_status_order' );
	
	$orderpayment->save();
	J2StoreHelperCart::removeOrderItems( $order->order_id );
	return $this->_getLayout('redirect', $vars);
	}

function getVersion() {
    if(is_null($this->_j2version)) {
        $xmlfile = JPATH_ADMINISTRATOR.'/components/com_j2store/manifest.xml';
        $xml = JFactory::getXML($xmlfile);
        $this->_j2version=(string)$xml->version;
    }
    return $this->_j2version;
}

function getCurrency($order) {
    $results = array();
    $convert = false;
    $params = JComponentHelper::getParams('com_j2store');

    if( version_compare( $this->_j2version, '2.6.7', 'lt' ) ) {
        $currency_code = $params->get('currency_code', 'USD');
        $currency_value = 1;
    } else {
        $currency_code = $order->currency_code;
        $currency_value = $order->currency_value;
    }
    $results['currency_code'] = $currency_code;
    $results['currency_value'] = $currency_value;
    $results['convert'] = $convert;
    return $results;
}
function _getCountryCode($country_id) {
    $db = JFactory::getDBO();
    $query = 'SELECT * FROM #__j2store_countries WHERE country_id='.$db->quote($country_id);
    $db->setQuery($query);
    $row = $db->loadObject();
    return $row;
}
function _getOrderInfo($orderpayment_id) {
    $db = JFactory::getDBO();
    $query = 'SELECT * FROM #__j2store_orderinfo WHERE orderpayment_id='.$db->Quote($orderpayment_id);
    $db->setQuery($query);
    return $db->loadObject();
}
function _getOrderPaymentId($order_id) {
    $db = JFactory::getDBO();
    $query = 'SELECT id FROM #__j2store_orders WHERE order_id='.$db->quote($order_id);
    $db->setQuery($query);
    return $db->loadResult();

}
function getAmount($value, $currency_code, $currency_value, $convert=false) {
    if( version_compare( $this->_j2version, '2.6.7', 'lt' ) ) {
        return J2StoreUtilities::number( $value, array( 'thousands'=>'', 'num_decimals'=>'2', 'decimal'=>'.') );
    } else {
        include_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/base.php');
        $currencyObject = J2StoreFactory::getCurrencyObject();
        $amount = $currencyObject->format($value, $currency_code, $currency_value, false);
        return $amount;
    }

}

function _getParam($name, $default = '') {
    $param = $this->params->get($name, $default);
    return $param;
}


}